Index: trunk/src/winmm/joyos2.cpp
===================================================================
--- trunk/src/winmm/joyos2.cpp	(revision 9975)
+++ trunk/src/winmm/joyos2.cpp	(revision 9976)
@@ -1,3 +1,3 @@
-/* $Id: joyos2.cpp,v 1.4 2000-02-17 14:09:30 sandervl Exp $ */
+/* $Id: joyos2.cpp,v 1.5 2003-04-02 12:59:23 sandervl Exp $ */
 /*
  * OS/2 Joystick apis
@@ -37,5 +37,5 @@
 //******************************************************************************
 //******************************************************************************
-LONG JoyOpen(HFILE *phGame)
+LONG JoyOpen(HANDLE *phGame)
 {
   ULONG   action;
@@ -58,5 +58,5 @@
 //******************************************************************************
 //******************************************************************************
-LONG JoyGetParams(HFILE hGame, GAME_PARM_STRUCT *pGameParams)
+LONG JoyGetParams(HANDLE hGame, GAME_PARM_STRUCT *pGameParams)
 {
   ULONG             dataLen;
@@ -86,5 +86,5 @@
 //    call get status with wait
 // Then call set calibration IOCTL with these values
-LONG JoyCalibrate(HFILE hGame, GAME_CALIB_STRUCT  gameCalib)
+LONG JoyCalibrate(HANDLE hGame, GAME_CALIB_STRUCT  gameCalib)
 {
   ULONG              parmLen;
@@ -106,5 +106,5 @@
 //******************************************************************************
 //******************************************************************************
-LONG JoyGetStatus( HFILE hGame, GAME_STATUS_STRUCT  *pGameStatus )
+LONG JoyGetStatus( HANDLE hGame, GAME_STATUS_STRUCT  *pGameStatus )
 {
   ULONG               dataLen;
@@ -125,5 +125,5 @@
 //******************************************************************************
 //******************************************************************************
-LONG JoyClose( HFILE hGame )
+LONG JoyClose( HANDLE hGame )
 {
   APIRET  rc;
@@ -135,5 +135,5 @@
 //******************************************************************************
 //******************************************************************************
-LONG JoyGetCalValues( HFILE hGame, GAME_CALIB_STRUCT  *pGameCalib )
+LONG JoyGetCalValues( HANDLE hGame, GAME_CALIB_STRUCT  *pGameCalib )
 {
   ULONG              dataLen;
@@ -158,5 +158,5 @@
 {
   BOOL             flReturn=1; // MMSYSERR_NODRIVER
-  HFILE            hJoy;
+  HANDLE            hJoy;
   APIRET           rc;
   GAME_PARM_STRUCT GameParams;
Index: trunk/src/winmm/joyos2.h
===================================================================
--- trunk/src/winmm/joyos2.h	(revision 9975)
+++ trunk/src/winmm/joyos2.h	(revision 9976)
@@ -1,3 +1,3 @@
-/* $Id: joyos2.h,v 1.2 1999-06-30 11:29:40 sandervl Exp $ */
+/* $Id: joyos2.h,v 1.3 2003-04-02 12:59:24 sandervl Exp $ */
 /*
  * Odin Joystick apis
@@ -78,10 +78,10 @@
 } GAME_DIGSET_STRUCT;
 
-LONG JoyOpen( HFILE *phGame );
-LONG JoyGetParams( HFILE hGame, GAME_PARM_STRUCT *pGameParams );
-LONG JoyCalibrate( HFILE hGame, GAME_CALIB_STRUCT  gameCalib );
-LONG JoyGetCalValues( HFILE hGame, GAME_CALIB_STRUCT *pGameCalib );
-LONG JoyGetStatus( HFILE hGame, GAME_STATUS_STRUCT  *pGameStatus );
-LONG JoyClose( HFILE hGame );
+LONG JoyOpen( HANDLE *phGame );
+LONG JoyGetParams( HANDLE hGame, GAME_PARM_STRUCT *pGameParams );
+LONG JoyCalibrate( HANDLE hGame, GAME_CALIB_STRUCT  gameCalib );
+LONG JoyGetCalValues( HANDLE hGame, GAME_CALIB_STRUCT *pGameCalib );
+LONG JoyGetStatus( HANDLE hGame, GAME_STATUS_STRUCT  *pGameStatus );
+LONG JoyClose( HANDLE hGame );
 LONG JoyInstalled(USHORT wID);
 
Index: trunk/src/winmm/mcicda/cdrom.h
===================================================================
--- trunk/src/winmm/mcicda/cdrom.h	(revision 9975)
+++ trunk/src/winmm/mcicda/cdrom.h	(revision 9976)
@@ -93,18 +93,18 @@
 BOOL	CDAUDIO_GetCDStatus(WINE_CDAUDIO* wcda);
 
-HFILE os2CDOpen(char *drive);
+HANDLE os2CDOpen(char *drive);
 ULONG os2CDClose(ULONG hfOS2Handle);
-int os2GetNumTracks(HFILE hfOS2Handle,ULONG *ulLeadOut);
-BOOL os2GetCDStatus(HFILE hfOS2Handle, ULONG  *ulStatus);
-BOOL os2GetCDAudioStatus(HFILE hfOS2Handle, USHORT  *usStatus);
-ULONG  os2CDQueryTrackStartSector( HFILE hfDrive, ULONG numTrack, BOOL *flAudio);
-BOOL os2CDEject(HFILE hfDrive);
-BOOL os2CDCloseTray(HFILE hfDrive);
-BOOL os2CDStop(HFILE hfDrive);
-BOOL os2CDPlayRange(HFILE hfDrive ,ULONG ulFrom, ULONG ulTo);
-BOOL  os2CDResume(HFILE hfDrive);
-BOOL os2CDGetHeadLocation(HFILE hfOS2Handle, ULONG  *ulHeadLocation);
-BOOL os2CDSeek(HFILE hfOS2Handle, ULONG  ulTo);
-BOOL os2CDQueryCurTrack(HFILE hfOS2Handle, UINT  * uiCurTrack);
+int os2GetNumTracks(HANDLE hfOS2Handle,ULONG *ulLeadOut);
+BOOL os2GetCDStatus(HANDLE hfOS2Handle, ULONG  *ulStatus);
+BOOL os2GetCDAudioStatus(HANDLE hfOS2Handle, USHORT  *usStatus);
+ULONG  os2CDQueryTrackStartSector( HANDLE hfDrive, ULONG numTrack, BOOL *flAudio);
+BOOL os2CDEject(HANDLE hfDrive);
+BOOL os2CDCloseTray(HANDLE hfDrive);
+BOOL os2CDStop(HANDLE hfDrive);
+BOOL os2CDPlayRange(HANDLE hfDrive ,ULONG ulFrom, ULONG ulTo);
+BOOL  os2CDResume(HANDLE hfDrive);
+BOOL os2CDGetHeadLocation(HANDLE hfOS2Handle, ULONG  *ulHeadLocation);
+BOOL os2CDSeek(HANDLE hfOS2Handle, ULONG  ulTo);
+BOOL os2CDQueryCurTrack(HANDLE hfOS2Handle, UINT  * uiCurTrack);
 BOOL os2CDQueryCDDrives(int *iNumCD, char * cFirstDrive);
 
Index: trunk/src/winmm/mcicda/os2cdrom.cpp
===================================================================
--- trunk/src/winmm/mcicda/os2cdrom.cpp	(revision 9975)
+++ trunk/src/winmm/mcicda/os2cdrom.cpp	(revision 9976)
@@ -15,4 +15,5 @@
 
 #include <os2wrap.h>
+#include <win32type.h>
 //#include <cdrom.h>
 
@@ -103,7 +104,7 @@
 
 
-HFILE os2CDOpen(char *drive)
-{
-    HFILE hfDrive = 0;
+HANDLE os2CDOpen(char *drive)
+{
+    HANDLE hfDrive = 0;
     ULONG ulAction;
     ULONG rc;
@@ -131,5 +132,5 @@
 	 other: # Audio tracks */
 /******************************************/
-int os2GetNumTracks(HFILE hfOS2Handle, ULONG *ulLeadOut)
+int os2GetNumTracks(HANDLE hfOS2Handle, ULONG *ulLeadOut)
 {
     ULONG ulParamLen;
@@ -180,5 +181,5 @@
 }	
 
-BOOL os2GetCDStatus(HFILE hfOS2Handle, ULONG  *ulStatus)
+BOOL os2GetCDStatus(HANDLE hfOS2Handle, ULONG  *ulStatus)
 {
     ULONG ulParamLen;
@@ -203,5 +204,5 @@
 }
 
-BOOL os2GetCDAudioStatus(HFILE hfOS2Handle, USHORT  *usStatus)
+BOOL os2GetCDAudioStatus(HANDLE hfOS2Handle, USHORT  *usStatus)
 {
     AUDIOSTATUS asStatus;
@@ -229,5 +230,5 @@
 /* Returns sector info of track #numTrack */
 /* Starting with track 0 */
-ULONG  os2CDQueryTrackStartSector( HFILE hfDrive, ULONG numTrack, BOOL *pflAudio)
+ULONG  os2CDQueryTrackStartSector( HANDLE hfDrive, ULONG numTrack, BOOL *pflAudio)
 {	
     ULONG ulParamLen;
@@ -281,5 +282,5 @@
 
 
-BOOL os2CDEject(HFILE hfDrive)
+BOOL os2CDEject(HANDLE hfDrive)
 {
     ULONG ulParamLen;
@@ -303,5 +304,5 @@
 #endif
 
-BOOL os2CDCloseTray(HFILE hfDrive)
+BOOL os2CDCloseTray(HANDLE hfDrive)
 {
     ULONG ulParamLen;
@@ -321,5 +322,5 @@
 }
 
-BOOL os2CDStop(HFILE hfDrive)
+BOOL os2CDStop(HANDLE hfDrive)
 {
     ULONG ulParamLen;
@@ -350,5 +351,5 @@
 /*                                       */
 /*****************************************/
-BOOL os2CDPlayRange(HFILE hfDrive ,ULONG ulFrom, ULONG ulTo)
+BOOL os2CDPlayRange(HANDLE hfDrive ,ULONG ulFrom, ULONG ulTo)
 {
     ULONG ulParamLen;
@@ -384,5 +385,5 @@
 }
 
-BOOL  os2CDResume(HFILE hfDrive)
+BOOL  os2CDResume(HANDLE hfDrive)
 {
     ULONG ulParamLen;
@@ -403,5 +404,5 @@
 }
 
-BOOL os2CDGetHeadLocation(HFILE hfOS2Handle, ULONG  *ulHeadLocation)
+BOOL os2CDGetHeadLocation(HANDLE hfOS2Handle, ULONG  *ulHeadLocation)
 {
     UCHAR ucParam[5]={0};
@@ -437,5 +438,5 @@
 }
 
-BOOL os2CDSeek(HFILE hfOS2Handle, ULONG  ulTo)
+BOOL os2CDSeek(HANDLE hfOS2Handle, ULONG  ulTo)
 {
     SEEKPARAM sp={0};
@@ -466,5 +467,5 @@
 }
 
-BOOL os2CDQueryCurTrack(HFILE hfOS2Handle, UINT  * uiCurTrack)
+BOOL os2CDQueryCurTrack(HANDLE hfOS2Handle, UINT  * uiCurTrack)
 {
     ULONG ulParamLen;
@@ -503,5 +504,5 @@
 BOOL os2CDQueryCDDrives(int *iNumCD, char * cFirstDrive)
 {
-  HFILE hfDevice;
+  HANDLE hfDevice;
   ULONG ulAction;
   ULONG ulLen;