Index: trunk/src/user32/oslibwin.cpp
===================================================================
--- trunk/src/user32/oslibwin.cpp	(revision 10012)
+++ trunk/src/user32/oslibwin.cpp	(revision 10013)
@@ -1,3 +1,3 @@
-/* $Id: oslibwin.cpp,v 1.141 2003-03-27 11:02:26 sandervl Exp $ */
+/* $Id: oslibwin.cpp,v 1.142 2003-04-11 15:22:33 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -62,5 +62,5 @@
                           char *pszName, HWND Owner, ULONG fHWND_BOTTOM,
                           ULONG id, BOOL fTaskList,BOOL fShellPosition,
-                          int classStyle, HWND *hwndFrame)
+                          DWORD classStyle, HWND *hwndFrame)
 {
  HWND  hwndClient;
@@ -101,4 +101,5 @@
                            Owner, (fHWND_BOTTOM) ? HWND_BOTTOM : HWND_TOP,
                            id, (PVOID)&FCData, NULL);
+
     if(fOS2Look && *hwndFrame) {
         FCData.flCreateFlags = dwOSFrameStyle;
@@ -142,5 +143,7 @@
         *OSWinStyle |= WS_TOPMOST;
 
-  if(fOS2Look) {
+  //WS_EX_TOOLWINDOW is incompatible with the OS2Look (titlebar thinner + smaller font)
+  if(fOS2Look && !(dwExStyle & WS_EX_TOOLWINDOW_W)) 
+  {
       if((dwStyle & WS_CAPTION_W) == WS_CAPTION_W) {
           *OSFrameStyle = FCF_TITLEBAR;
@@ -176,4 +179,10 @@
 
   dprintf(("OSLibWinPositionFrameControls %x (%x,%x) %x %d", hwndFrame, dwStyle, dwExStyle, hSysMenuIcon, drawCloseButton));
+
+  //WS_EX_TOOLWINDOW is incompatible with the OS2Look (titlebar thinner + smaller font)
+  if(dwExStyle & WS_EX_TOOLWINDOW_W) {
+      DebugInt3();
+      return FALSE;
+  }
 
   if(minmaxwidth == 0) {
@@ -1075,5 +1084,6 @@
       dwWinStyle &= ~WS_MAXIMIZED;
 
-    if(fOS2Look) {
+    //WS_EX_TOOLWINDOW is incompatible with the OS2Look (titlebar thinner + smaller font)
+    if(fOS2Look && !(dwExStyle & WS_EX_TOOLWINDOW_W)) {
         ULONG OSFrameStyle = 0;
         SWP rc1,rc2,rc3;
@@ -1164,6 +1174,6 @@
 
    if(dwWinStyle != dwOldWinStyle) {
-          dprintf(("Setting new window U long"));
-          WinSetWindowULong(hwndFrame, QWL_STYLE, dwWinStyle);
+       dprintf(("Setting new window U long"));
+       WinSetWindowULong(hwndFrame, QWL_STYLE, dwWinStyle);
    }
 
Index: trunk/src/user32/oslibwin.h
===================================================================
--- trunk/src/user32/oslibwin.h	(revision 10012)
+++ trunk/src/user32/oslibwin.h	(revision 10013)
@@ -1,3 +1,3 @@
-/* $Id: oslibwin.h,v 1.74 2003-03-27 11:02:26 sandervl Exp $ */
+/* $Id: oslibwin.h,v 1.75 2003-04-11 15:22:33 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -44,5 +44,5 @@
                            char *pszName, HWND Owner, ULONG fBottom,
                            ULONG id, BOOL fTaskList,BOOL fShellPosition, 
-                           int classStyle, HWND *hwndFrame);
+                           DWORD classStyle, HWND *hwndFrame);
 
 BOOL  OSLibWinConvertStyle(ULONG dwStyle, ULONG dwExStyle, ULONG *OSWinStyle, 
Index: trunk/src/user32/win32wbase.cpp
===================================================================
--- trunk/src/user32/win32wbase.cpp	(revision 10012)
+++ trunk/src/user32/win32wbase.cpp	(revision 10013)
@@ -1,3 +1,3 @@
-/* $Id: win32wbase.cpp,v 1.365 2003-03-29 16:38:00 sandervl Exp $ */
+/* $Id: win32wbase.cpp,v 1.366 2003-04-11 15:22:33 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2
@@ -1390,5 +1390,6 @@
   }
 #endif
-  if(fOS2Look && ((dwStyle & WS_CAPTION) == WS_CAPTION))
+  //WS_EX_TOOLWINDOW is incompatible with the OS2Look (titlebar thinner + smaller font)
+  if(fOS2Look && ((dwStyle & WS_CAPTION) == WS_CAPTION) && !(dwExStyle & WS_EX_TOOLWINDOW)) 
   {
       RECT rect = {0};
Index: trunk/src/user32/win32wbasenonclient.cpp
===================================================================
--- trunk/src/user32/win32wbasenonclient.cpp	(revision 10012)
+++ trunk/src/user32/win32wbasenonclient.cpp	(revision 10013)
@@ -1,3 +1,3 @@
-/* $Id: win32wbasenonclient.cpp,v 1.50 2003-02-28 09:56:00 sandervl Exp $ */
+/* $Id: win32wbasenonclient.cpp,v 1.51 2003-04-11 15:22:34 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2 (non-client methods)
@@ -906,5 +906,6 @@
   HBITMAP memBmp,oldBmp;
 
-  if(fOS2Look) {
+  //WS_EX_TOOLWINDOW is incompatible with the OS2Look (titlebar thinner + smaller font)
+  if(fOS2Look && !(dwExStyle & WS_EX_TOOLWINDOW)) {
       //Note: If no class icon *and* WS_EX_DLGMODALFRAME -> no system menu
       if((dwStyle & WS_SYSMENU) && !(dwExStyle & WS_EX_TOOLWINDOW) &&
@@ -1014,5 +1015,7 @@
     }
 
-    if ((dwStyle & WS_MAXIMIZEBOX) || (dwStyle & WS_MINIMIZEBOX))
+    //Testing in NT4 shows that tool windows never have a minimize or maximize button!
+    if (((dwStyle & WS_MAXIMIZEBOX) || (dwStyle & WS_MINIMIZEBOX)) &&
+        !(dwExStyle & WS_EX_TOOLWINDOW))
     {
       /* In win95 the two buttons are always there */